function [sig_m cov_mc sig_rc sig_r  SR sig_rq RB40]=get_secondmoments(Qmat)

global M_ oo_

%% Evaluate Parameters
NumberOfParameters = M_.param_nbr;                            % Number of deep parameters.
for i = 1:NumberOfParameters                                  % Loop...
  paramname = deblank(M_.param_names(i,:)) ;                 %    Get the name of parameter i. 
  eval([ paramname ' = M_.params(' int2str(i) ');'])        %    Get the value of parameter i.
end

%% 

kk=oo_.dr.order_var;


row_m = strmatch('M', M_.endo_names(kk,:), 'exact');
row_r = strmatch('r', M_.endo_names(kk,:), 'exact');
row_rc = strmatch('Rc', M_.endo_names(kk,:), 'exact');
row_rq = strmatch('rq', M_.endo_names(kk,:), 'exact');

row_mn = strmatch('MN', M_.endo_names(kk,:), 'exact');
row_lamb = strmatch('lamb', M_.endo_names(kk,:), 'exact');


trans_row_m=oo_.dr.ghu(row_m,:);
trans_row_mn=oo_.dr.ghu(row_mn,:);
trans_row_r=oo_.dr.ghu(row_r,:);
trans_row_rc=oo_.dr.ghu(row_rc,:);
trans_row_rq=oo_.dr.ghu(row_rq,:);


% Secon Moments
sig_m=sqrt(trans_row_m*(Qmat)*trans_row_m')/100;
sig_r=sqrt(trans_row_r*(Qmat)*trans_row_r')/100;
sig_rc=sqrt(trans_row_rc*(Qmat)*trans_row_rc')/100;
sig_rq=sqrt(trans_row_rq*(Qmat)*trans_row_rq')/100;

cov_mc=trans_row_m*(Qmat)*trans_row_rc'/100;
cov_mq=trans_row_m*(Qmat)*trans_row_rq'/100;

% Sharpe Ratio

SR=-cov_mc/sig_rc/100;
SR_q=-cov_mq/sig_rq/100;

% Volatility MN(+40)

 endo_nbr = M_.endo_nbr;
    nstatic = oo_.dr.nstatic;
    npred = oo_.dr.npred;
    iv = (1:endo_nbr)';
    ic = [ nstatic+(1:npred) endo_nbr+(1:size(oo_.dr.ghx,2)-npred) ]';
    aux = oo_.dr.transition_auxiliary_variables;
    k = find(aux(:,2) > npred);
    aux(:,2) = aux(:,2) + nstatic;
    aux(k,2) = aux(k,2) + oo_.dr.nfwrd;
    
[KT,KI] = kalman_transition_matrix(oo_.dr,iv,ic,aux,M_.exo_nbr);

%%
 B = KI.* repmat(sqrt(diag(Qmat)'),M_.endo_nbr,1);
 BB=B*B';          

V=zeros(M_.endo_nbr,M_.endo_nbr);
VM=zeros(M_.endo_nbr,M_.endo_nbr,40);
for jj=1:40
       V=(KT)*V*(KT)'+BB;         
       VM(:,:,jj)=  V;
  
end

VM=sum(VM,3);
sig2_mnk=sqrt(diag(VM));

sig_M40=sig2_mnk(row_mn)/100;
%sig2_mnk(row_lamb)/100

crreal=1+constebeta/100;
cpie=1+constepinf/100;
cgamma=1+ctrend/100 ;
cbetabar=1/(crreal*exp(sig_m^2/2)*cgamma^(-csigma));
cr=cpie/(cbetabar*exp(sig_m^2/2)*cgamma^(-csigma));

cr40=cpie/(cbetabar*exp(sig_M40^2/2/40)*cgamma^(-csigma));

RB40=(log(cr40)-log(cr))*10000;

%sqrt(BB(row_mn,row_mn))/100


