function [sig_m cov_mc sig_rc sig_r sig_rq cov_mq SR SR_q]=get_secondmoments(Qmat)

global M_ oo_

%% Evaluate Parameters
NumberOfParameters = M_.param_nbr;                            % Number of deep parameters.
for i = 1:NumberOfParameters                                  % Loop...
  paramname = deblank(M_.param_names(i,:)) ;                 %    Get the name of parameter i. 
  eval([ paramname ' = M_.params(' int2str(i) ');'])        %    Get the value of parameter i.
end

%% 

kk=oo_.dr.order_var;


row_m = strmatch('m', M_.endo_names(kk,:), 'exact');
row_r = strmatch('r', M_.endo_names(kk,:), 'exact');
row_rc = strmatch('rc', M_.endo_names(kk,:), 'exact');
row_rq = strmatch('rq', M_.endo_names(kk,:), 'exact');


trans_row_m=oo_.dr.ghu(row_m,:);
trans_row_r=oo_.dr.ghu(row_r,:);
trans_row_rc=oo_.dr.ghu(row_rc,:);
trans_row_rq=oo_.dr.ghu(row_rq,:);

sig_m=sqrt(trans_row_m*(Qmat)*trans_row_m');

sig_r=sqrt(trans_row_r*(Qmat)*trans_row_r');
sig_rc=sqrt(trans_row_rc*(Qmat)*trans_row_rc');
sig_rq=sqrt(trans_row_rq*(Qmat)*trans_row_rq');

cov_mc=trans_row_m*(Qmat)*trans_row_rc';
cov_mq=trans_row_m*(Qmat)*trans_row_rq';

SR=-cov_mc/sig_rc;

SR_q=-cov_mq/sig_rq;

