

var w wf y k x c l r rc n q ld cd lambda m s H F zL zI eps_w g
    rq,dy_obs, cy_obs, dx_obs;



varexo eP eL eI eG eW eQ;

parameters  eta, delta, theta, ngamma, nzeta, mu, chi, ppsi,
            rho_c, rho_l,  eps_w_bar, FEinv, 
            piL, piI, piW, piG, gy_bar,
            sig_m, cov_mc, sig_rc, sig_r, sig_rq, cov_mq, SR, SR_q,
            r_bar, Omega;


setparams;

model(linear);
#m_bar=exp(-sig_m^2/2)/exp(r_bar);
#betta=m_bar*exp(eta*ngamma);
#rc_bar=1/m_bar/exp(sig_m^2/2+cov_mc);
#delta_tilde=exp(ngamma)+delta-1; 
#xybar=theta*delta_tilde/(rc_bar+delta-1);
#yk_bar=(rc_bar+delta-1)/theta; 
#ck_bar=yk_bar-(gy_bar*yk_bar)-delta_tilde;
#l_bar=2/3;
#kappa=(1-l_bar)/l_bar*ck_bar/yk_bar*exp(eps_w_bar)/(1-theta);
#CapY=l_bar/(1-l_bar)*FEinv-(2-1/eta)/(1-chi)/kappa;
#nu=1-(1-ppsi)*CapY;
#allpha=kappa*nu*(1-chi)/(1-ppsi)-1;
#A=allpha*(1-ppsi)^nu*l_bar^nu;
#n_bar=1-l_bar;
#k_bar=yk_bar^(1/(theta-1))* n_bar * exp(ngamma); 
#y_bar=yk_bar*k_bar; 
#c_bar=ck_bar*k_bar; 
#x_bar=delta_tilde*k_bar;
#g_bar=gy_bar*y_bar;
// Investment equations (in comparison to correction_v6 I use the inverse of q 

rc=((rc_bar-1+delta)/rc_bar)*y -((rc_bar-1+delta)/rc_bar)* k(-1)+exp(ngamma)/rc_bar*q-q(-1)+delta_tilde/rc_bar*zI; 

q+zI=1/nzeta*x-1/nzeta*k(-1)+1/nzeta*zI;

//  Euler Equations and Pricing Kernel

0=rc(+1)+m(+1);

0=r+m(+1);

m=lambda-lambda(-1)-eta*s(-1); 

// Marginal Utility and Habit Formation

lambda=-eta*cd + (nu*(1-eta)/(1+allpha))*ld; 

(1-chi)*cd=c-chi*H(-1); 

(1-ppsi)*ld=zL+l-ppsi*F(-1);

H+s=(1-rho_c)*c+rho_c*H(-1);

F=(1-rho_l)*l+rho_l*F(-1);

// equ. regarding wage setting 

w=y-n; 

wf=cd +zL + (nu*allpha/(1+allpha)-1)*ld; 

w=mu*w(-1)+(1-mu)*wf -mu*s(-1)+(1-mu)*eps_w; 

// additional standard equations

y_bar*y=c_bar*c+x_bar*x+g_bar*g; 

y=theta*k(-1)+(1-theta)*n + (1-theta)*s; 

-n_bar/(1-n_bar)*n=l; 

exp(ngamma)*k=(1-delta)*k(-1)+delta_tilde*x+ delta_tilde*zI  -exp(ngamma)*s; 

// additional "dummy" variable for shock eP because dynare does not allow for direct eP(-1) 

s=eP;

g= piG*g(-1) + eG;
zI= piI*zI(-1) + eI;
zL= piL*zL(-1)+eL; 
eps_w=piW*eps_w(-1)+eW;


// level observables




// data observables

dy_obs=y-y(-1)+s(-1);
cy_obs=c-c(-1)+s(-1);
dx_obs=x-y;
rq=SR*sig_rq+1/(1-Omega)*(rc-r)+eQ;

end;



shocks;
var eP = .0091^2;
var eI = .0140^2;
var eL = .0032^2;
var eW = .0153^2;
var eG = .0194^2;
var eQ = .0194^2;
end;


resid(1);
steady;

// Make sure that rq is named last, IMPORTANT for mean of corresponding time series!!!!

varobs dy_obs n cy_obs dx_obs r rq;


estimated_params;

mu, 0.28, beta_pdf, 0.75,0.15;
eta,105, uniform_pdf,,,1,200;
chi,0.84, beta_pdf, 0.5 ,.23 ;
ppsi,0.84,beta_pdf, 0.5 ,.23;

rho_c,0.655,beta_pdf, 0.5 ,.23;
rho_l,0.06,beta_pdf, 0.5 ,.23;

Omega,0.11,beta_pdf,0.5,0.23;
nzeta,7.7, normal_pdf, 4, 1;
delta,0.0176, beta_pdf, 0.02, 0.0025;
FEinv, 7.1 , gamma_pdf, 1,0.75;
r_bar, 0.0044,inv_gamma_pdf, 0.005,0.01; 

// AR(1) Parameter

piG,0.92, beta_pdf, 0.85, 0.1;
piI,0.70, beta_pdf, 0.85, 0.1;
piL,0.65, beta_pdf, 0.85, 0.1;
piW,0.92, beta_pdf, 0.85, 0.1;

// s.d. shocks
stderr eG, 0.0191, inv_gamma_pdf, 0.01, 4;
stderr eI,  0.0135, inv_gamma_pdf, 0.01, 4;
stderr eL,0.0029, inv_gamma_pdf, 0.01, 4;
stderr eP,0.009, inv_gamma_pdf, 0.01, 4;
stderr eW,0.0212, inv_gamma_pdf, 0.01, 4;
stderr eQ,0.0757, inv_gamma_pdf, 0.01, 4;
end;
     
   

//stoch_simul(order=1, irf=0, nograph);


estimation(order=1,datafile=data_KU, 
mh_replic=0, mh_jscale=0.5, mh_init_scale=1, mh_drop=0.75,
mode_file=model2_lin_mode,
//load_mh_file,
mh_nblocks=2, mode_compute=4)y c x n r;



