function posterior_analysis(type,Y,gend,data_index,missing_value,hp)
% 

global options_ estim_params_ oo_ M_ bayestopt_

nvx  = estim_params_.nvx;
nvn  = estim_params_.nvn;
ncx  = estim_params_.ncx;
ncn  = estim_params_.ncn;
np   = estim_params_.np ;
npar = nvx+nvn+ncx+ncn+np;
offset = npar-np;
naK = length(options_.filter_step_ahead);
%%
MaxNumberOfBytes=options_.MaxNumberOfBytes;
endo_nbr=M_.endo_nbr;
exo_nbr=M_.exo_nbr;
nvobs     = size(options_.varobs,1);
iendo = 1:endo_nbr;
horizon = options_.forecast;
% moments_varendo = options_.moments_varendo;
filtered_vars = options_.filtered_vars;
if horizon
    i_last_obs = gend+(1-M_.maximum_endo_lag:0);
end
maxlag = M_.maximum_endo_lag;
%%
DirectoryName = CheckPath('metropolis');
load([ DirectoryName '/'  M_.fname '_mh_history'])
FirstMhFile = record.KeepedDraws.FirstMhFile;
FirstLine = record.KeepedDraws.FirstLine; 
TotalNumberOfMhFiles = sum(record.MhDraws(:,2)); LastMhFile = TotalNumberOfMhFiles; 
TotalNumberOfMhDraws = sum(record.MhDraws(:,1));
NumberOfDraws = TotalNumberOfMhDraws-floor(options_.mh_drop*TotalNumberOfMhDraws);
clear record;
if ~isempty(options_.subdraws)
    B = options_.subdraws;
    if B > NumberOfDraws
        B = NumberOfDraws;
    end
else
    B = min(1200, round(0.25*NumberOfDraws));
end
%B=10;
NN=B;
%%
MAX_nruns = min(B,ceil(MaxNumberOfBytes/(npar+2)/8));
MAX_nsmoo = min(B,ceil(MaxNumberOfBytes/((endo_nbr)*gend)/8));
MAX_ninno = min(B,ceil(MaxNumberOfBytes/(exo_nbr*gend)/8));
MAX_nerro = min(B,ceil(MaxNumberOfBytes/(size(options_.varobs,1)*gend)/8));
if naK
    MAX_naK   = min(B,ceil(MaxNumberOfBytes/(size(options_.varobs,1)* ...
                                             length(options_.filter_step_ahead)*gend)/8));
end
if horizon
    MAX_nforc1 = min(B,ceil(MaxNumberOfBytes/((endo_nbr)*(horizon+maxlag))/8));
    MAX_nforc2 = min(B,ceil(MaxNumberOfBytes/((endo_nbr)*(horizon+maxlag))/ ...
                            8));
    IdObs    = bayestopt_.mfys;

end
MAX_momentsno = min(B,ceil(MaxNumberOfBytes/(get_moments_size(options_)*8)));
%%
varlist = options_.varlist;
if isempty(varlist)
    varlist = M_.endo_names(1:M_.orig_endo_nbr, :);
end
nvar = size(varlist,1);
SelecVariables = [];
for i=1:nvar
    if ~isempty(strmatch(varlist(i,:),M_.endo_names,'exact'))
        SelecVariables = [SelecVariables;strmatch(varlist(i,:),M_.endo_names,'exact')];
    end
end

irun = ones(7,1);
ifil = zeros(7,1);

if exist('OCTAVE_VERSION')
    diary off;
else
    h = waitbar(0,'Taking subdraws...');
end

stock_param = zeros(MAX_nruns, npar);
stock_logpo = zeros(MAX_nruns,1);
stock_ys = zeros(MAX_nruns,endo_nbr);
run_smoother = 0;



[ivar,vartan] = set_stationary_variables_list;
%NN=100;


nar = options_.ar;

stdY=zeros(nvar,NN);
SR_draw=zeros(1,NN);
RB40_draw=zeros(1,NN);
CorY=zeros(nvar,nvar,NN);

ACorY= zeros(nar,nvar,NN);
CrossCorr=zeros(2*nar-1,sum(1:nvar-1),NN);
metropolis_draw(1);

for nn=1:NN
    
      
                  
    [deep, logpo] = GetOneDraw(type);
    set_all_parameters(deep);
    [T,R,SteadyState,info] = dynare_resolve(bayestopt_.restrict_var_list,...
					  bayestopt_.restrict_columns,...
					  bayestopt_.restrict_aux);
    dr = resol(oo_.steady_state,0);

        
    
    endo_nbr = M_.endo_nbr;
exo_names_orig_ord  = M_.exo_names_orig_ord;
if exist('OCTAVE_VERSION')
    warning('off', 'Octave:divide-by-zero')
else
    warning off MATLAB:dividebyzero
end

options_.hp_filter=hp;

[Gamma_y,ivar]=th_autocovariances(dr,ivar,M_,options_);

 
[nu, betta, allpha, A,  sig_m, cov_mc, sig_rc,...
      sig_r, SR, xybar, eta,cy_bar, EIS,sig_rq, cov_mq,  SR_q, RB40]=addpara2_dynare;
SR_draw(1,nn)=SR;
RB40(1,nn)=RB40;
clear nu betta allpha A sig_m cov_mc sig_rc sig_r SR EIS sig_rq RB40 eta cy_bar cov_mq;

stdY_dum= sqrt(diag(real(Gamma_y{1})));
stdY(:,nn) =stdY_dum;
CorY(:,:,nn) = real(Gamma_y{1})./(stdY_dum*stdY_dum');
ACorY(1,:,nn)=ones(nvar,1)';
Gamma_y_backup=Gamma_y{1};
Gamma_y{1}=real(Gamma_y{1})./(stdY_dum*stdY_dum');

for rr = 1:nar;
    %% E[yy,x(lag rr)]
    yyxxd(:,nvar*(rr-1)+1:nvar*rr) = reshape(Gamma_y{rr+1},nvar,nvar);
    %yyxxd(:,nvar*(rr-1)+1:nvar*rr) = Gamma_y{rr+1}./(stdY*stdY');
    
    %% E[x(lag rr),x(lag ll)]
    for ll = rr:nar;  
        yyyydrrll = reshape(Gamma_y{ll-rr+1},nvar,nvar);
        %yyyydrrll =reshape(Gamma_y{:,ll-rr+1},n_var,n_var)./(stdY*stdY');
        xxxxd(nvar*(rr-1)+1:nvar*rr,nvar*(ll-1)+1:nvar*ll) = yyyydrrll(1:nvar,1:nvar);
        xxxxd(nvar*(ll-1)+1:nvar*ll,nvar*(rr-1)+1:nvar*rr) = yyyydrrll(1:nvar,1:nvar)';
    end
end

TT=reshape(xxxxd(1:end,1:nvar)',nvar,nvar,nar);

rr=0;
for jj=1:nvar-1
    for kk=jj+1:nvar
     rr=rr+1;   
    CrossCorr(5:end,rr,nn)=squeeze(TT(jj,kk,:));
             H1=   flipud( squeeze(TT(kk,jj,:)));
    CrossCorr(1:4,rr,nn)=H1(1:4);
    end
    
end

for i=2:nar
    
    ACorY(i,:,nn)= diag(Gamma_y{i})';

end

    stock_param(irun(5),:) = deep;
    stock_logpo(irun(5),1) = logpo;
  %  stock_ys(irun(5),:) = SteadyState';

    irun = irun +  ones(7,1);


    
    if exist('OCTAVE_VERSION')
        printf('Taking subdraws: %3.f%% done\r', nn/NN);
    else
        waitbar(nn/NN,h);
    end
end

if exist('OCTAVE_VERSION')
    printf('\n');
    diary on;
else
    close(h)
end



save('posterior_draws_mom.mat','stdY', 'CorY', 'ACorY','CrossCorr','SR_draw')
